## camltemplate 1.0.2

=== Makefile ===
DIRS := src examples doc
VERSION := $(shell grep version src/META | sed -e 's/version="//' -e 's/".*//')
DIST_DIR := camltemplate-$(VERSION)

# PKGBASE is provided by GODIVA.
ifeq ($(PKGBASE),)
PKGBASE := camltemplate
endif
export PKGBASE

# Builds bytecode.
.PHONY: all
all: Makefile.config
	cd src; $(MAKE) all
	cd examples; $(MAKE) all

# Builds native code.
.PHONY: opt
opt: Makefile.config
	cd src; $(MAKE) opt

# Builds HTML documentation.
.PHONY: htdoc
htdoc: Makefile.config
	cd doc; make htdoc

# Builds documentation in all formats.
.PHONY: pdfdoc
pdfdoc: Makefile.config
	cd doc; make pdfdoc

# Runs a regression test.
.PHONY: test
test:
	test/test.sh

# Installs the library.
.PHONY: install
install: Makefile.config
	cd src; $(MAKE) install
	cd doc; $(MAKE) install
	cd examples; $(MAKE) install

# Uninstalls the library.
.PHONY: uninstall
uninstall: Makefile.config
	cd src; $(MAKE) uninstall
	cd doc; $(MAKE) uninstall
	cd examples; $(MAKE) uninstall

# Creates a distribution tarball.
.PHONY: dist
dist: distclean all htdoc pdfdoc
	set -e; \
	./configure; \
	rm -rf $(DIST_DIR)*; \
	files=`ls`; \
	mkdir $(DIST_DIR); \
	cp -r $$files $(DIST_DIR); \
	find $(DIST_DIR) -type d -name CVS -prune -exec rm -rf \{} \;
	cd $(DIST_DIR); \
	for dir in $(DIRS); do \
		if [ $$dir != "doc" ]; then \
			cd $$dir; $(MAKE) clean; cd ..; \
		fi; \
	done; \
	cd doc; $(MAKE) distclean; cd ../..; \
	rm -f $(DIST_DIR)/Makefile.config; \
	tar zcf $(DIST_DIR).tar.gz $(DIST_DIR); \
	rm -rf $(DIST_DIR)

# Copies the distribution and docs into the SauceCode web site.
.PHONY: webinstall
webinstall: $(DIST_DIR).tar.gz
	cp -r doc/html/api doc/html/manual ../../saucecode-site/saucecode.org/htdocs/camltemplate
	mkdir -p ../../saucecode-site/saucecode.org/htdocs/camltemplate/releases
	cp $(DIST_DIR).tar.gz ../../saucecode-site/saucecode.org/htdocs/camltemplate/releases

# Deletes generated files.
.PHONY: clean
clean:
	for dir in $(DIRS); do cd $$dir; $(MAKE) clean; cd ..; done
	rm -rf *~ camltemplate-*

.PHONY: distclean
distclean: clean
	rm -f Makefile.config
	./configure

=== doc/Makefile ===
TOP_DIR=..
-include $(TOP_DIR)/Makefile.config
include $(TOP_DIR)/Makefile.rules

DOC_MLI := ../src/camlTemplate.mli
INSTALL_DIR := $(PREFIX)/doc/$(PKGBASE)

.PHONY: htdoc
htdoc: html/api/index.html html/manual/index.html

html/api/index.html: $(TOP_DIR)/src/camlTemplate.mli
	mkdir -p html
	rm -rf html/api
	mkdir -p html/api
	ocamldoc -I ../src -html -d html/api -t "CamlTemplate API Documentation" $(DOC_MLI)

html/manual/index.html: manual/manual.tex
	mkdir -p html
	rm -rf html/manual
	mkdir -p html/manual
	cd manual; \
	hevea -fix -O -o manual.html manual.tex; \
	hacha manual.html; \
	cp *.html *.css *.gif ../html/manual

.PHONY: pdfdoc
pdfdoc: pdf/manual.pdf

pdf/manual.pdf: manual/manual.tex
	set -e; rm -rf pdf; mkdir pdf; \
	cd manual; \
	latex manual.tex; \
	latex manual.tex; \
	dvips -o manual.ps manual.dvi; \
	ps2pdf manual.ps ../pdf/manual.pdf

.PHONY: install
install:
	rm -rf $(INSTALL_DIR)
	mkdir -p $(INSTALL_DIR)
	mkdir -p html pdf
	cp -r html pdf $(INSTALL_DIR)

.PHONY: uninstall
uninstall:
	rm -rf $(INSTALL_DIR)

.PHONY: clean
clean:
	rm -rf html pdf *~
	cd manual; rm -f *~ *.html *.css *.gif *.log *.out *.aux *.dvi *.ps \
	   *.htoc *.image.tex *.haux *.pdf .log

.PHONY: distclean
distclean:
	cd manual; rm -f *.html *.css *.gif *.htoc *.image.tex *.haux *.aux \
		*.log *.dvi *.ps

=== examples/Makefile ===
TOP_DIR=..
-include $(TOP_DIR)/Makefile.config
include $(TOP_DIR)/Makefile.rules

BUILD_EXAMPLES := hello filetest thread
ALL_EXAMPLES := $(BUILD_EXAMPLES) mod_caml fastcgi
INSTALL_DIR := $(PREFIX)/share/$(PKGBASE)

.PHONY: all
all:
	set -e; for dir in $(BUILD_EXAMPLES); do cd $$dir; $(MAKE) all; cd ..; done

.PHONY: clean
clean:
	for dir in $(ALL_EXAMPLES); do cd $$dir; $(MAKE) clean; cd ..; done
	rm -f *~

.PHONY: install
install:
	rm -rf $(INSTALL_DIR)
	mkdir -p $(INSTALL_DIR)/examples
	cp $(TOP_DIR)/OCamlMakefile $(INSTALL_DIR)
	cp -r examples.rules $(ALL_EXAMPLES) $(INSTALL_DIR)/examples
	find $(INSTALL_DIR)/examples -type d -name CVS -prune -exec rm -rf \{} \;
	find $(INSTALL_DIR)/examples -type d -name ._d -prune -exec rm -rf \{} \;

.PHONY: uninstall
uninstall:
	rm -rf $(INSTALL_DIR)

=== src/Makefile ===

OCAMLC:=ocamlfind ocamlc
TOP_DIR := ..
-include $(TOP_DIR)/Makefile.config
include $(TOP_DIR)/Makefile.rules

MLY:=ctParser.mly
MLL:=ctLexer.mll

SOURCES :=\
	ctUtil.ml ctSourcePos.ml ctExceptions.ml ctTemplateModel.ml \
	ctScope.ml ctTemplateTypes.ml ctContext.ml \
	ctExpression.ml ctIdent.ml ctUnop.ml \
	ctBinop.ml ctLiteral.ml ctFunctionCall.ml ctHashLookup.ml \
	ctStatement.ml ctMacro.ml \
	ctParserAux.ml ctParser.mli ctParser.ml ctLexer.ml \
	ctWeb.ml ctTemplate.ml ctCache.mli ctCache.ml \
	camlTemplate.mli camlTemplate.ml

ALL_ML:=$(filter %.ml,$(SOURCES))

ALL_CMO:=$(foreach s,$(ALL_ML), $(basename $(notdir $(s))).cmo)
ALL_CMX:=$(foreach s,$(ALL_ML), $(basename $(notdir $(s))).cmx)

FLAGS:=
OPTS:=
LIB_POSTFIX:=

all:
	ocamllex $(MLL) && \
	ocamlyacc $(MLY) && \
	ocamlfind ocamlc $(OPTS) -linkpkg -c $(SOURCES) && \
	ocamlfind ocamlc -thread -c camlTemplate_mt.ml && \
	ocamlfind ocamlc -a -o camltemplate.cma $(ALL_CMO)

opt:
	ocamllex $(MLL) && \
	ocamlyacc $(MLY) && \
	ocamlfind ocamlopt $(OPTS) -linkpkg -c $(SOURCES) && \
	ocamlfind ocamlopt -thread -c camlTemplate_mt.ml && \
	ocamlfind ocamlopt -a -o camltemplate.cmxa $(ALL_CMX)

install:
	files=`$(COLLECT_FILES) META camlTemplate.mli camlTemplate.cmi camltemplate.cma camltemplate.cmxa camltemplate.a camlTemplate_mt.cmo camlTemplate_mt.cmx camlTemplate_mt.o` && \
	$(OCAMLFIND) install -destdir $(PREFIX) camltemplate $$files

uninstall:
	$(OCAMLFIND) remove -destdir $(PREFIX) camltemplate

clean:
	rm -rf *.o *.a *.cm? mt_cmis *.cm?a ctLexer.ml ctParser.ml ctParser.mli *~
	rm -rf ._bcdi ._ncdi ._d

=== examples/fastcgi/Makefile ===
TOP_DIR := ../..
-include $(TOP_DIR)/Makefile.rules
include ../examples.rules

# Change this to the directory where you've compiled Christophe
# Troestler's CamlGI package.
CAMLGI_DIR = ../../../CamlGI-0.5

# Change this to the directory where you install CGI programs to be run
# by FastCGI.
FCGI_BINDIR := /var/www/fcgi-bin

TEMPLATEDIR := $(FCGI_BINDIR)/templates

INCDIRS := -I $(CAMLGI_DIR) -I $(CAMLTEMPLATE_DIR)

BYTE_LIBS := unix.cma threads.cma str.cma camlGI.cma camltemplate.cma
BYTE_LIBS+=camlTemplate_mt.cmo

NATIVE_LIBS := unix.cmxa threads.cmxa str.cmxa camlGI.cmxa camltemplate.cmxa
NATIVE_LIBS+=camlTemplate_mt.cmx

SOURCES := fcgihello.ml
RESULT := fcgihello

.PHONY: all opt clean install
all: 
	ocamlc -thread $(INCDIRS) -o $(RESULT) $(BYTE_LIBS) $(SOURCES)

opt:
	ocamlopt -thread $(INCDIRS) -o $(RESULT) $(NATIVE_LIBS) $(SOURCES)

clean:
	rm -rf $(RESULT) *.cm? *.o *~ ._d

install:
	mkdir -p $(FCGI_BINDIR)
	cp fcgihello $(FCGI_BINDIR)
	mkdir -p $(TEMPLATEDIR)
	cp fcgihello.tmpl $(TEMPLATEDIR)

=== examples/filetest/Makefile ===
TOP_DIR := ../..
-include $(TOP_DIR)/Makefile.config
-include $(TOP_DIR)/Makefile.rules
include ../examples.rules

INCDIRS := $(shell ocamlfind query ) $(CAMLTEMPLATE_DIR)
LIBS := unix str camltemplate

SOURCES := filetest.ml
RESULT := filetest

TRASH := *~ coleridge.html

OCAMLMAKEFILE := $(TOP_DIR)/OCamlMakefile

.PHONY: all
all: byte-code

include $(TOP_DIR)/OCamlMakefile

=== examples/hello/Makefile ===
TOP_DIR := ../..
-include $(TOP_DIR)/Makefile.config
-include $(TOP_DIR)/Makefile.rules
include ../examples.rules

INCDIRS := $(CAMLTEMPLATE_DIR)
LIBS := unix str camltemplate

SOURCES := hello.ml
RESULT := hello

TRASH := *~

OCAMLMAKEFILE := $(TOP_DIR)/OCamlMakefile

.PHONY: all
all: byte-code

include $(TOP_DIR)/OCamlMakefile

=== examples/mod_caml/Makefile ===
TOP_DIR := ../..
-include $(TOP_DIR)/Makefile.rules
include ../examples.rules

# Change this to the directory where you install .cmo files to be run
# by mod_caml.
MODCAML_BINDIR := /var/www/caml-bin

# Change this to the directory where you want to install templates.
TEMPLATEDIR := /var/www/caml-templates

# Where to find the 'apache' package installed by mod_caml.
OCAMLLIBDIR := $(shell ocamlc -where)

INCDIRS := $(OCAMLLIBDIR)/apache $(CAMLTEMPLATE_DIR)
LIBS := unix str cgi camltemplate

SOURCES := cthello.ml

TRASH := *~ cthello.ml

OCAMLMAKEFILE := $(TOP_DIR)/OCamlMakefile

.PHONY: all
all: cthello.ml byte-code-nolink

cthello.ml: cthello.ml.in
	sed -e 's,@TEMPLATEDIR@,$(TEMPLATEDIR),g' \
	< $< > $@

.PHONY: install
install:
	mkdir -p $(MODCAML_BINDIR)
	cp cthello.cmo $(MODCAML_BINDIR)
	mkdir -p $(TEMPLATEDIR)
	cp cthello.tmpl $(TEMPLATEDIR)

include $(TOP_DIR)/OCamlMakefile

=== examples/thread/Makefile ===
TOP_DIR := ../..
-include $(TOP_DIR)/Makefile.rules
include ../examples.rules

INCDIRS := -I $(shell ocamlfind query str) -I $(CAMLTEMPLATE_DIR)
BYTE_LIBS := unix.cma str.cma threads.cma camltemplate.cma camlTemplate_mt.cmo
NATIVE_LIBS := unix.cmxa str.cmxa threads.cmxa camltemplate.cmxa camlTemplate_mt.cmx

SOURCES := thread_test.ml
RESULT := thread_test

.PHONY: all opt clean
all: 
	ocamlc -thread $(INCDIRS) -o $(RESULT) $(BYTE_LIBS) $(SOURCES)

opt:
	ocamlopt -thread $(INCDIRS) -o $(RESULT) $(NATIVE_LIBS) $(SOURCES)

clean:
	rm -f $(RESULT) *.cm? *.o *~

=== debian/changelog ===
camltemplate (1.0.2-3) unstable; urgency=medium

  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Sun, 01 Sep 2019 21:02:39 +0200

camltemplate (1.0.2-2) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * Switch debian/copyright to format 1.0
  * Update Vcs-*
  * Bump debhelper compat to 10
  * Bump Standards-Version to 4.0.1

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders (Closes: #869321)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 08 Aug 2017 15:25:20 +0200

camltemplate (1.0.2-1) unstable; urgency=low

  * Initial release. (Closes: #605675)

 -- Sylvain Le Gall <gildor@debian.org>  Tue, 07 Dec 2010 15:09:45 +0000

=== debian/control ===
Source: camltemplate
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
  ocaml-nox (>= 3.11.1-3~),
  ocaml-findlib,
  dh-ocaml (>= 0.9~),
  debhelper (>= 10)
Standards-Version: 4.0.1
Homepage: http://camltemplate.forge.ocamlcore.org/
Vcs-Git: https://salsa.debian.org/ocaml-team/camltemplate.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/camltemplate

Package: libcamltemplate-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: configurable library for generating text from templates in OCaml
 CamlTemplate is a library for generating text from templates in OCaml. It can
 be used to generate web pages, scripts, SQL queries, XML documents and other
 sorts of text.
 .
 This library defines a small templating language, with basic operations like
 #if or #foreach. To use this library you need to configure the data source
 that will be used in the template with the templating language.

Package: libcamltemplate-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: configurable library for generating text from templates in OCaml
 CamlTemplate is a library for generating text from templates in OCaml. It can
 be used to generate web pages, scripts, SQL queries, XML documents and other
 sorts of text.
 .
 This library defines a small templating language, with basic operations like
 #if or #foreach. To use this library you need to configure the data source
 that will be used in the template with the templating language.
 .
 This package contains the shared runtime libraries.

=== debian/watch ===
version=3
http://forge.ocamlcore.org/frs/?group_id=35 \
    .*/camltemplate-([\d\.]*)\.tar\.gz
